/*
   Problema Elastico -- elastico.c
   Seletiva IOI 2003
   Guilherme Ottoni
   Algoritmo: programacao dinamica.
              complexidade: O(n^3)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define TAM 202

int max_vertices[TAM][TAM];
int n;
struct Pto
{
  int x, y;
} pontos[TAM];

/* compara os pontos para ordenar em sentido anti-horario */
int compara(const void *p1, const void *p2)
{
  struct Pto *pto1 = (struct Pto *)p1;
  struct Pto *pto2 = (struct Pto *)p2;
  return pto2->x * pto1->y - pto2->y * pto1->x;
}

/* vetor de pontos[i] ateh pontos[j] */
struct Pto vetor(int i, int j)
{
  struct Pto v;
  v.x = pontos[j].x - pontos[i].x;
  v.y = pontos[j].y - pontos[i].y;
  return v;
}

/* produto vetorial a x b */
int prod_vet(struct Pto a, struct Pto b)
{
  return a.x * b.y - a.y * b.x;
}

int main()
{
  int i, j, k, teste=1, maximo;
  while (scanf("%d", &n) == 1 && n > 0)
    {
      pontos[0].x = pontos[0].y = 0;
      for (i = 1; i <= n; i++)
	scanf("%d %d", &pontos[i].x, &pontos[i].y);
      qsort(&pontos[1], n, sizeof(struct Pto), compara);
      maximo = 0;
      /* preenche tabela de programacao dinamica: 
	 max_vertices[i][j]: maximo de vertices de um poligono iniciando em 
                             pontos[0],..., pontos[j], pontos[i], pontos[0] */
      max_vertices[0][0] = 1;
      for (i = 1; i <= n; i++)
	{
	  max_vertices[i][0] = 2;
	  for (j = 1; j < i; j++)
	    {
	      max_vertices[i][j] = 0;
	      for (k = 0; k < j; k++)
		if (max_vertices[j][k] >= max_vertices[i][j] && 
		    prod_vet(vetor(k, j), vetor(j, i)) > 0)
		  max_vertices[i][j] = max_vertices[j][k] + 1;
	      if (max_vertices[i][j] > maximo)
		maximo = max_vertices[i][j];
	    }
	}
      printf("Teste %d\n%d\n\n", teste++, maximo);
   }
  return 0;
}
